﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GroupByMultipleColumns
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.DataSource = GridInfo.GetAppointments();

            this.ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Subject", false, true);
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("OwnerKey", false, true);
        }

        private void ultraGrid1_InitializeGroupByRow(object sender, InitializeGroupByRowEventArgs e)
        {
            var rowID = e.Row.Column.Key;
            UltraGridRow row;

            switch (rowID)
            {
                case "Subject":
                    e.Row.Appearance.BackColor = Color.LightSteelBlue;
                    string str = getString("StartTime", e.Row);
                    row = e.Row.GetChild(ChildRow.First);
                    str = string.Format("Description: {0}", str);
                    e.Row.Description = str;
                    
                    break;
                case "OwnerKey":
                    e.Row.Description = "Some text...";
                    e.Row.Appearance.BackColor = Color.Yellow;
                    break;
            }
        }

        private string getString(string ColKey, UltraGridGroupByRow groupRow)
        {
            if (groupRow == null)
                return null;
            if (groupRow.ChildBands.FirstRow.IsGroupByRow)
                return getString(ColKey, (UltraGridGroupByRow)groupRow.ChildBands.FirstRow);
            else
                return groupRow.ChildBands.FirstRow.Cells[ColKey].Text;
        }


    }
}
